module HoughVoting(
	oaddress_m4k,
	idata_m4k,
	clock,
	oaddress_SRAM,
	data_SRAM_in,
	data_SRAM_out,
	owren_SRAM,
	iReset,
	iled

	
	);	
	
	output [19:0] oaddress_m4k;
	input idata_m4k;
	input clock;
	output reg [19:0] oaddress_SRAM;
	input [15:0] data_SRAM_in;
	output [15:0] data_SRAM_out;
	output reg owren_SRAM;
	input iReset;
	output reg iled;
	
	reg [15:0] temp_data_SRAM;
	reg [4:0] state;
	
	reg signed [4:0] hdirection, vdirection, rdirection;
	reg [19:0] raddress_m4k;
	
	assign oaddress_m4k = raddress_m4k;
	
	parameter verify = 5'd0;
	parameter wait1 = 5'd1;
	parameter sum = 5'd2;
	parameter sum1 = 5'd3;
	parameter sum2 = 5'd4;
	parameter sum3 = 5'd5;
	parameter sum4 = 5'd6;
	parameter sum5 = 5'd7;
	parameter sum6 = 5'd8;
	parameter sum7 = 5'd9;
	parameter vote = 5'd10;
	parameter increment = 5'd11;
	parameter increment1 = 5'd12;	
	parameter done = 5'd13;	
	
	assign data_SRAM_out = temp_data_SRAM;
	
	always@(posedge clock)
	begin
		if (iReset)
		begin
			raddress_m4k <= 20'd641;
			hdirection <= 0;
			vdirection <= 0;
			state <= verify;
			owren_SRAM <= 0;
			oaddress_SRAM <= 20'd0;
			iled <= 1'b0;
			
		end
		else
		begin
			case (state)
				verify:	begin
					owren_SRAM <= 0;
					if(raddress_m4k < 20'd307100) //if(idata_m4k)
					begin
						
						raddress_m4k <= raddress_m4k - 20'd641;
						hdirection <= 0;
						vdirection <= 0;
						state <= wait1;
						iled <= 1'b0;
					end
					else
					begin
					/*	if(raddress_m4k < 20'd307100)
						begin
							raddress_m4k <= raddress_m4k + 20'd1;
							state <= verify;
						end
						else*/	
							state <= done;
												
					end
				end	
				
				done: begin
					owren_SRAM <= 0;
					iled <= 1'b1;
					state <= done;
				end
				
				wait1: begin
					state <= sum;
					raddress_m4k <= raddress_m4k + 20'd1;
				end
				
				sum: begin
					hdirection <= -idata_m4k;
					vdirection <= -idata_m4k;
					raddress_m4k <= raddress_m4k + 20'd1;
					state <= sum1;
				end
				
				sum1: begin
					vdirection <= vdirection - idata_m4k - idata_m4k;
					raddress_m4k <= raddress_m4k + 20'd638;
					state <= sum2;
				end
				
				sum2: begin
					vdirection <= vdirection - idata_m4k;
					hdirection <= hdirection + idata_m4k;
					raddress_m4k <= raddress_m4k + 20'd2;
					state <= sum3;
				end
				
				sum3: begin
					
					hdirection <= hdirection - idata_m4k - idata_m4k;
					raddress_m4k <= raddress_m4k + 20'd638;
					state <= sum4;
				end
				
				sum4: begin
					hdirection <= hdirection + idata_m4k + idata_m4k;
					raddress_m4k <= raddress_m4k + 20'd1;
					state <= sum5;
				end
				
				sum5: begin
					vdirection <= vdirection + idata_m4k;
					hdirection <= hdirection - idata_m4k;
					raddress_m4k <= raddress_m4k + 20'd1;
					state <= sum6;
				end
				
				sum6: begin
					vdirection <= vdirection + idata_m4k + idata_m4k;
					raddress_m4k <= raddress_m4k - 20'd640;
					state <= sum7;
				end
				
				sum7: begin
					hdirection <= hdirection + idata_m4k;
					vdirection <= vdirection + idata_m4k;
					state <= vote;
				end
				
				vote: begin
					if(hdirection > 0)
					begin
						if(vdirection > 0) begin
							oaddress_SRAM <= raddress_m4k + 20'd1282; //Radius/2 * 640 + Radius/2 
							state <= increment;
						end
						else if (vdirection < 0) begin
							oaddress_SRAM <= raddress_m4k - 20'd1278; // - Radius/2 * 640 + Radius/2 
							state <= increment;
						end
						else
						begin
							oaddress_SRAM <= raddress_m4k + 20'd4; // Radius 
							state <= increment;
						end
					end	
					else if ( hdirection < 0)begin
						if(vdirection > 0) begin
							oaddress_SRAM <= raddress_m4k + 20'd1278; //Radius/2 * 640 + Radius/2 
							state <= increment;
						end
						else if (vdirection < 0) begin
							oaddress_SRAM <= raddress_m4k - 20'd1282; // - Radius/2 * 640 + Radius/2 
							state <= increment;
						end
						else
						begin
							oaddress_SRAM <= raddress_m4k - 20'd4; // Radius 
							state <= increment;
						end
					end
					else
						state <= verify;
					
				end
				
				increment: begin
					if (oaddress_SRAM[0])
						temp_data_SRAM <= data_SRAM_in + 16'd1;
					else
						temp_data_SRAM <= data_SRAM_in + 16'b0000000100000000;
					owren_SRAM <= 0;
					state <= increment1;
				end
				
				increment1: begin
					owren_SRAM <= 1;
					state <= verify;
				end
				
			endcase
		end
	end
	

	
	endmodule
	 
	 