`include "scan_events.h"
module MidiVoting (
	
	input iCLK,
	input iRESET,
	input [10:0] iCursor_Y,
	input [10:0] iSymbolType,
	output reg [17:0] oSRAM_Address,
	output [15:0] oSRAM_data


);

wire [7:0] note_value;
wire [7:0] symbol_value;




parameter a_01_line=11'd244, a_02_line=11'd250, a_03_line=11'd256, a_04_line=11'd262, a_05_line=11'd268, a_11_line=11'd318, a_12_line=11'd324, a_13_line=11'd330, a_14_line=11'd336, a_15_line=11'd342;
parameter a_21_line=11'd395, a_22_line=11'd401, a_23_line=11'd407, a_24_line=11'd413, a_25_line=11'd419;
parameter a_06_line=11'd274, a_16_line=11'd348, a_26_line=11'd425;

parameter a_00_space=11'd241, a_01_space=11'd247, a_02_space=11'd253, a_03_space=11'd259, a_04_space=11'd265, a_05_space=11'd271, a_10_space=11'd315, a_11_space=11'd321, a_12_space=11'd327, a_13_space=11'd333, a_14_space=11'd339, a_15_space=11'd345;
parameter a_20_space=11'd392, a_21_space=11'd398, a_22_space=11'd404, a_23_space=11'd410, a_24_space=11'd416, a_25_space=11'd422;

parameter fnote_up_x=11'd45, hnote_up_x=64, qnote_up_x=11'd83, enote_up_x=11'd102, snote_up_x=11'd122, tnote_up_x=11'd144, sfnote_up_x=11'd165;
parameter frest_up_x=11'd320, hrest_up_x=11'd339, qrest_up_x=11'd358, erest_up_x=11'd378, srest_up_x=11'd397, trest_up_x=11'd415, sfrest_up_x=11'd435;






assign symbol_value = (iSymbolType == fnote_up_x ? 8'd1 :
							  iSymbolType == hnote_up_x ? 8'd2 :
							  iSymbolType == qnote_up_x ? 8'd3 :
							  iSymbolType == enote_up_x ? 8'd4 :
							  iSymbolType == snote_up_x ? 8'd5 :
							  iSymbolType == tnote_up_x ? 8'd6 :
							  iSymbolType == sfnote_up_x? 8'd7 :
							  iSymbolType == frest_up_x ? 8'd8 :
							  iSymbolType == hrest_up_x ? 8'd9 :
							  iSymbolType == qrest_up_x ? 8'd10 :
							  iSymbolType == erest_up_x ? 8'd11 :
							  iSymbolType == srest_up_x ? 8'd12 :
							  iSymbolType == trest_up_x ? 8'd13 :
							  iSymbolType == sfrest_up_x? 8'd14 : 0);









//Note convertion
wire [10:0] Cursor_Off_1;
assign Cursor_Off_1 = iCursor_Y - 1;
wire [10:0] Cursor_On_1;
assign Cursor_On_1 = iCursor_Y + 1;


assign note_value = (   (Cursor_Off_1  == a_01_line) ? 	`HIGH_F	:
							   (iCursor_Y     == a_01_line) ?	`HIGH_F	:
								(Cursor_On_1   == a_01_line) ?	`HIGH_F	:
								(Cursor_Off_1  == a_02_line) ? 	`HIGH_D	:
							   (iCursor_Y     == a_02_line) ?	`HIGH_D	:
								(Cursor_On_1   == a_02_line) ?	`HIGH_D	:
								(Cursor_Off_1  == a_03_line) ? 	`LOW_B 	:
							   (iCursor_Y     == a_03_line) ?	`LOW_B 	:
								(Cursor_On_1   == a_03_line) ?	`LOW_B 	:
								(Cursor_Off_1  == a_04_line) ? 	`LOW_G 	:
							   (iCursor_Y     == a_04_line) ?	`LOW_G 	:
								(Cursor_On_1   == a_04_line) ?	`LOW_G 	:
								(Cursor_Off_1  == a_05_line) ? 	`LOW_E 	:
							   (iCursor_Y     == a_05_line) ?	`LOW_E	:
								(Cursor_On_1   == a_05_line) ?	`LOW_E	:
								(Cursor_Off_1  == a_06_line) ? 	`LOW_C	:
							   (iCursor_Y     == a_06_line) ?	`LOW_C	:
								(Cursor_On_1   == a_06_line) ?	`LOW_C	:
								(Cursor_Off_1  == a_11_line) ? 	`HIGH_F	:
							   (iCursor_Y     == a_11_line) ? 	`HIGH_F	:
								(Cursor_On_1   == a_11_line) ? 	`HIGH_F	:
								(Cursor_Off_1  == a_12_line) ? 	`HIGH_D	:
							   (iCursor_Y     == a_12_line) ? 	`HIGH_D	:
								(Cursor_On_1   == a_12_line) ? 	`HIGH_D	:
								(Cursor_Off_1  == a_13_line) ? 	`LOW_B 	:
							   (iCursor_Y     == a_13_line) ? 	`LOW_B 	:
								(Cursor_On_1   == a_13_line) ? 	`LOW_B 	:
								(Cursor_Off_1  == a_14_line) ? 	`LOW_G 	:
							   (iCursor_Y     == a_14_line) ? 	`LOW_G 	:
								(Cursor_On_1   == a_14_line) ? 	`LOW_G 	:
								(Cursor_Off_1  == a_15_line) ? 	`LOW_E 	:
							   (iCursor_Y     == a_15_line) ? 	`LOW_E 	:
								(Cursor_On_1   == a_15_line) ? 	`LOW_E 	:
								(Cursor_Off_1  == a_16_line) ? 	`LOW_C 	:
							   (iCursor_Y     == a_16_line) ? 	`LOW_C 	:
								(Cursor_On_1   == a_16_line) ? 	`LOW_C 	:
								(Cursor_Off_1  == a_21_line) ? 	`HIGH_F	:
							   (iCursor_Y     == a_21_line) ? 	`HIGH_F	:
								(Cursor_On_1   == a_21_line) ? 	`HIGH_F	:
								(Cursor_Off_1  == a_22_line) ? 	`HIGH_D	:
							   (iCursor_Y     == a_22_line) ? 	`HIGH_D	:
								(Cursor_On_1   == a_22_line) ? 	`HIGH_D	:
								(Cursor_Off_1  == a_23_line) ? 	`LOW_B 	:
							   (iCursor_Y     == a_23_line) ? 	`LOW_B  	:
								(Cursor_On_1   == a_23_line) ? 	`LOW_B 	:
								(Cursor_Off_1  == a_24_line) ? 	`LOW_G 	:
							   (iCursor_Y     == a_24_line) ? 	`LOW_G 	:
								(Cursor_On_1   == a_24_line) ? 	`LOW_G 	:
								(Cursor_Off_1  == a_25_line) ? 	`LOW_E 	:
							   (iCursor_Y     == a_25_line) ? 	`LOW_E 	:
								(Cursor_On_1   == a_25_line) ? 	`LOW_E 	:
								(Cursor_Off_1  == a_26_line) ? 	`LOW_C 	:
							   (iCursor_Y     == a_26_line) ? 	`LOW_C 	:
								(Cursor_On_1   == a_26_line) ? 	`LOW_C 	: //fim de linhas
								(Cursor_Off_1  == a_00_space)? 	`HIGH_G  :
							   (iCursor_Y     == a_00_space)? 	`HIGH_G	:
								(Cursor_On_1   == a_00_space)? 	`HIGH_G	:
								(Cursor_Off_1  == a_01_space)? 	`HIGH_E	:
							   (iCursor_Y     == a_01_space)? 	`HIGH_E	:
								(Cursor_On_1   == a_01_space)? 	`HIGH_E	:
								(Cursor_Off_1  == a_02_space)? 	`HIGH_C	:
							   (iCursor_Y     == a_02_space)? 	`HIGH_C	:
								(Cursor_On_1   == a_02_space)? 	`HIGH_C	:
								(Cursor_Off_1  == a_03_space)? 	`LOW_A	:
							   (iCursor_Y     == a_03_space)? 	`LOW_A	:
								(Cursor_On_1   == a_03_space)? 	`LOW_A	:
								(Cursor_Off_1  == a_04_space)? 	`LOW_F	:
							   (iCursor_Y     == a_04_space)? 	`LOW_F	:
								(Cursor_On_1   == a_04_space)? 	`LOW_F	:
								(Cursor_Off_1  == a_05_space)? 	`LOW_D	:
							   (iCursor_Y     == a_05_space)? 	`LOW_D	:
								(Cursor_On_1   == a_05_space)? 	`LOW_D	:
								(Cursor_Off_1  == a_10_space)? 	`HIGH_G	:
							   (iCursor_Y     == a_10_space)? 	`HIGH_G	:
								(Cursor_On_1   == a_10_space)? 	`HIGH_G	:
								(Cursor_Off_1  == a_11_space)? 	`HIGH_E	:
							   (iCursor_Y     == a_11_space)? 	`HIGH_E	:
								(Cursor_On_1   == a_11_space)? 	`HIGH_E	:
								(Cursor_Off_1  == a_12_space)? 	`HIGH_C	:
							   (iCursor_Y     == a_12_space)? 	`HIGH_C	:
								(Cursor_On_1   == a_12_space)? 	`HIGH_C	:
								(Cursor_Off_1  == a_13_space)? 	`LOW_A	:
							   (iCursor_Y     == a_13_space)? 	`LOW_A	:
								(Cursor_On_1   == a_13_space)? 	`LOW_A	:
								(Cursor_Off_1  == a_14_space)? 	`LOW_F	:
							   (iCursor_Y     == a_14_space)? 	`LOW_F	:
								(Cursor_On_1   == a_14_space)? 	`LOW_F	:
								(Cursor_Off_1  == a_15_space)? 	`LOW_D	:
							   (iCursor_Y     == a_15_space)? 	`LOW_D	:
								(Cursor_On_1   == a_15_space)? 	`LOW_D	:
								(Cursor_Off_1  == a_20_space)? 	`HIGH_G	:
							   (iCursor_Y     == a_20_space)? 	`HIGH_G	:
								(Cursor_On_1   == a_20_space)? 	`HIGH_G	:
								(Cursor_Off_1  == a_21_space)? 	`HIGH_E	:
							   (iCursor_Y     == a_21_space)? 	`HIGH_E	:
								(Cursor_On_1   == a_21_space)? 	`HIGH_E	:
								(Cursor_Off_1  == a_22_space)? 	`HIGH_C	:
							   (iCursor_Y     == a_22_space)? 	`HIGH_C	:
								(Cursor_On_1   == a_22_space)? 	`HIGH_C	:
								(Cursor_Off_1  == a_23_space)? 	`LOW_A	:
							   (iCursor_Y     == a_23_space)? 	`LOW_A	:
								(Cursor_On_1   == a_23_space)? 	`LOW_A	:
								(Cursor_Off_1  == a_24_space)? 	`LOW_F	:
							   (iCursor_Y     == a_24_space)? 	`LOW_F	:
								(Cursor_On_1   == a_24_space)? 	`LOW_F	:
								(Cursor_Off_1  == a_25_space)? 	`LOW_D	:
							   (iCursor_Y     == a_25_space)? 	`LOW_D	:
								(Cursor_On_1   == a_25_space)? 	`LOW_D	:
								0
								
);


assign oSRAM_data = {note_value,symbol_value};

always@(posedge iCLK or posedge iRESET) begin
	if(iRESET) begin
		oSRAM_Address <= 0;
	end
	else begin
		oSRAM_Address <= oSRAM_Address + 8'd1;
	end
end



endmodule
